<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListaExtratoContaEstabelecimentoResponse StructType
 * @subpackage Structs
 */
class ListaExtratoContaEstabelecimentoResponse extends AbstractStructBase
{
    /**
     * The ListaExtratoContaEstabelecimentoResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfV_SDD_ExtratoContaERP
     */
    public $ListaExtratoContaEstabelecimentoResult;
    /**
     * The mensagem
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mensagem;
    /**
     * The sucesso
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $sucesso;
    /**
     * Constructor method for ListaExtratoContaEstabelecimentoResponse
     * @uses ListaExtratoContaEstabelecimentoResponse::setListaExtratoContaEstabelecimentoResult()
     * @uses ListaExtratoContaEstabelecimentoResponse::setMensagem()
     * @uses ListaExtratoContaEstabelecimentoResponse::setSucesso()
     * @param \ArrayType\ArrayOfV_SDD_ExtratoContaERP $listaExtratoContaEstabelecimentoResult
     * @param string $mensagem
     * @param bool $sucesso
     */
    public function __construct(\ArrayType\ArrayOfV_SDD_ExtratoContaERP $listaExtratoContaEstabelecimentoResult = null, $mensagem = null, $sucesso = null)
    {
        $this
            ->setListaExtratoContaEstabelecimentoResult($listaExtratoContaEstabelecimentoResult)
            ->setMensagem($mensagem)
            ->setSucesso($sucesso);
    }
    /**
     * Get ListaExtratoContaEstabelecimentoResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfV_SDD_ExtratoContaERP|null
     */
    public function getListaExtratoContaEstabelecimentoResult()
    {
        return isset($this->ListaExtratoContaEstabelecimentoResult) ? $this->ListaExtratoContaEstabelecimentoResult : null;
    }
    /**
     * Set ListaExtratoContaEstabelecimentoResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfV_SDD_ExtratoContaERP $listaExtratoContaEstabelecimentoResult
     * @return \StructType\ListaExtratoContaEstabelecimentoResponse
     */
    public function setListaExtratoContaEstabelecimentoResult(\ArrayType\ArrayOfV_SDD_ExtratoContaERP $listaExtratoContaEstabelecimentoResult = null)
    {
        if (is_null($listaExtratoContaEstabelecimentoResult) || (is_array($listaExtratoContaEstabelecimentoResult) && empty($listaExtratoContaEstabelecimentoResult))) {
            unset($this->ListaExtratoContaEstabelecimentoResult);
        } else {
            $this->ListaExtratoContaEstabelecimentoResult = $listaExtratoContaEstabelecimentoResult;
        }
        return $this;
    }
    /**
     * Get mensagem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensagem()
    {
        return isset($this->mensagem) ? $this->mensagem : null;
    }
    /**
     * Set mensagem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensagem
     * @return \StructType\ListaExtratoContaEstabelecimentoResponse
     */
    public function setMensagem($mensagem = null)
    {
        // validation for constraint: string
        if (!is_null($mensagem) && !is_string($mensagem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensagem)), __LINE__);
        }
        if (is_null($mensagem) || (is_array($mensagem) && empty($mensagem))) {
            unset($this->mensagem);
        } else {
            $this->mensagem = $mensagem;
        }
        return $this;
    }
    /**
     * Get sucesso value
     * @return bool|null
     */
    public function getSucesso()
    {
        return $this->sucesso;
    }
    /**
     * Set sucesso value
     * @param bool $sucesso
     * @return \StructType\ListaExtratoContaEstabelecimentoResponse
     */
    public function setSucesso($sucesso = null)
    {
        // validation for constraint: boolean
        if (!is_null($sucesso) && !is_bool($sucesso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sucesso)), __LINE__);
        }
        $this->sucesso = $sucesso;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListaExtratoContaEstabelecimentoResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
